/* mytoc.c
 * file for tokenizer
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "mytoc.h"


char ** mytoc(char * inStr){

	//copy input string
	char * copyStr = strdup(inStr);
	if (copyStr == 0){
		fprintf(stdout,"Virtual mem exhausted.\n");
		exit(10);
	}	
	//defensively malloc output array length with length of inString (could be all spaces)
	char ** outArr = (char**) malloc(strlen(inStr)*sizeof(void*));
	if (outArr == 0){
		fprintf(stdout,"Virtual mem exhausted.\n");
		exit(10);
	}	
		
	//var for storing index into array
	int idx = 0;

	//start of current word
	char * wordStart = copyStr;

	//pointer to run over string, set to beginning of copied string
	char * ptr = copyStr;
	
	//and now run over the inString and transform ' ' to \0 and store pointers
	while (	*ptr != 0){
		//space?
		if (*ptr == ' '){
			*ptr = 0;
			outArr[idx++] = wordStart;
			wordStart = ptr+1;
		}
		ptr++;
	}
	
	//put last pointer in
	outArr[idx++] = wordStart;
	//and null pointer
	outArr[idx++] = (char*)NULL;
	
	
	return ((char**) outArr);
}
