/* shell.c
 * simple shell main prog
*/
#define MAX_VARS 10
#define PATH_MAX 255

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <fcntl.h>

#include "../lab0/mytoc.h"

int main(int argc, char ** argv){

	int i,n=PATH_MAX;
	//holds the command line
	char line[n];
	//buffer for misc things
	char buf[n];
	
	//holds vars
	char * names[MAX_VARS];
	memset(names,0,MAX_VARS*sizeof(char*));
	char * vals[MAX_VARS];
	int nextIdx = 0;
	//misc pointer 4 stuff
	char * ptr;
	//the token array
	char ** tokArr;
	//stats for backg jobs
	int pid,stat;

			
	while(!0){
		//check on background jobs and report if any have exited
		if ( 0 < (pid = waitpid (WAIT_ANY, &stat, WNOHANG)))
			fprintf(stdout,"[%i] finished with code: %i\n",pid,stat);
			
		//write $ to the screen
		fprintf(stdout,"$ ");
		fflush(stdout);
		
		//get line of input	
		fgets((char*)line,n,stdin);
		//remove newline
		line[strlen(line)-1] = 0;
		//and continue if empty
		if (!strlen(line)) continue;

		//get tokens
		tokArr = mytoc(line);
		//check for primitives (cd,var,echo)
		if(ptr = strchr(tokArr[0],'=')){
			//got a var, change = to 0
			*ptr = 0;
			//and store pointers in arrs
			names[nextIdx] = tokArr[0];
			vals[nextIdx] = ptr+1;
			fprintf(stdout,"%s set to %s\n",names[nextIdx],vals[nextIdx]);
			//store next free index, RR
			if (++nextIdx == MAX_VARS) nextIdx=0; 
		
		}else if(0==(strcmp(tokArr[0],"cd"))){
			//got a change dir
			if (chdir(tokArr[1]))
				perror("chdir");
			else 
				fprintf(stdout,"CWD is now %s\n",getcwd((char*)buf,PATH_MAX));
			
		}else if(0==(strcmp(tokArr[0],"echo"))){
			//look for requested var in array
			for (i=0;i<MAX_VARS;i++)
				if ( names[i] && ( 0==strcmp(names[i],((char*)tokArr[1])+1 )))
					//and print
					fprintf(stdout,"%s is: %s\n",names[i],vals[i]);
		}else{
			//ok gotta be a cmd
			short backg=0,pip=0;				//bools
			pid_t pid1=0,pid2=0;				//pids
			int mypipe[2],status1,status2;		//pipe,statuses
			char ** tokArr2 = NULL;				//cmdline of 2nd cmd

			//check if theres a & at the end
			if ( (ptr = strchr(line,'&'))  &&  (ptr == line+strlen(line)-1)  ){ 
					backg = 1;
					//remove, remove trailing space if exists and scan anew
					*ptr = 0;
					ptr--;
					if ( *ptr == ' ') *ptr = 0;
					tokArr = mytoc(line);
				}
				
			//now check for |
			if (ptr = strchr(line,'|')){
				*ptr = 0;
				//remove trailing space of first cmd
				if ( *(ptr-1) == ' ') *(ptr-1) = 0;
				//and scan anew
				tokArr = mytoc(line);
				//and leading of 2nd, when scanning
				tokArr2 = mytoc( (*(ptr+1)==' '?(ptr+2):(ptr+1) ));
				pip = 1;		//set bool=true
				if (pipe (mypipe)){
	      			perror("create pipe");
					continue;
				}
			}
			
			//fork first
			if ( (pid_t)0 == (pid1=fork())){
				//child1
				//change stdout when theres a pipe
				if (pip) dup2(mypipe[1],1);
				//and exec
				execvp(tokArr[0],(char**)tokArr);
				perror("Exec"); 
      			_exit(EXIT_FAILURE);
				
			}else if(pid1 < (pid_t)0){
     			/* fork failed.  */
      			perror("Fork first");
      			continue;
    		}else{
    			//parent
    			//print info if background
    			if (backg) fprintf (stdout, "'%s' [%i]\n",tokArr[0],pid1);
    			//fork 2nd if exist
    			if (tokArr2){
					//child2 has to wait for child1
					if (waitpid(pid1, &status1, 0) == pid1)
      					fprintf(stdout, "[%i] finished with exit code: %i\n",pid1,status1);
					//and close the writing end of the pipe
					close(mypipe[1]);
					if ( (pid_t)0 == (pid2=fork())){
						//change stdin when theres a pipe
						dup2(mypipe[0],0);
						//and exec
						execvp(tokArr2[0],(char**)tokArr2);
						perror("Exec"); 
						_exit(EXIT_FAILURE);
					
					}else if(pid2 < (pid_t)0){
    	 				/* fork failed.  */
		      			perror("Fork second");
	      				continue;
					}
					if (backg) fprintf (stdout, "'%s' [%i]\n",tokArr2[0],pid2);
	
				}
	   			
				//now see if we should wait
				if (!backg){
					if (waitpid(pid1, &status1, 0) == pid1)
      					fprintf(stdout, "[%i] finished with exit code: %i\n",pid1,status1);
	      			if (pid2 && waitpid(pid2, &status2, 0) == pid2)
      					fprintf(stdout, "[%i] finished with exit code: %i\n",pid2,status2);
				}
			}//end else for fork first
		}//end else for tokens
		free(tokArr);
	}//end while(1)
}//end main
