/* proc.c
 * struct representing a single process
 */

//defs for algos
#define UNI1		0
#define UNI2		1
#define RR			2
#define HPRN		3

//state of proc
#define READY 		0
#define RUNNING 	1
#define BLOCKED 	2
#define TERMINATED 	3

struct proc {
 
 	//from file
 	int A_arriv;
 	int C_total;
 	int B_burst_max;
 	int IO_max;
 	
 	//status
 	int state;
 	//IO
 	int blocked_till;
 	int blocked_since;
 	//CPU
 	int rung_till;
 	int rung_since;
 	int rung_for;
 	//waiting since
 	int ready_since;
 	//TERM
 	int term_at;
 	
 	//counters for total times
 	int tot_io_time;
 	int tot_ready_time;
 	int tot_running;
};

//shortcut a pointer
typedef struct proc * pproc; 
