/* tthreads.h */

#ifndef tthreads_included
#define tthreads_included

#include "setjmp.h"

typedef struct Thread_s {	/* a Thread */
  void (*initFn)(void *);
  void * initArg;
  jmp_buf context;
  int tid;
  struct Thread_s *next;	/* for readyq */
  int enqueued;			/* used as bool, for checking */
} Thread;


/* Thread Queue */
typedef struct {		
  Thread *head, *tail;
  int count;
} ThreadQ;

void initThreadQ(ThreadQ *tq);	
extern void enqueueThread(ThreadQ *tq, Thread *t);
extern Thread *dequeueThread(ThreadQ *tq);

extern ThreadQ readyQ;		/* ready queue (fcfs) */

/* initialize thread system; all threads put on "freshQ" */
extern void makeThreads(int n);	
/* start new thread running (*initFn)(initArg) */
extern int initAndScheduleThread(void (*initFn)(void *), void *initArg) ;
/* switch context (from readyQ) & enqueue self */
/* start threads, returns when all threads have terminated */
extern void startThreads();	
/* thread termination, or can just return */
extern void terminateThread();	

extern int getTid();		/* get thread id */
extern void yield();		/* volunteer for preemption */

extern void contextSwitch(ThreadQ *resched); 

#endif /* tthreads_included */

