#include <stdlib.h>

/* align everything to multiples of 8 */
#define align8(x) ((x+7) & ~7)
#define prefixSize align8(sizeof(BlockPrefix_t))
#define suffixSize align8(sizeof(BlockSuffix_t))

/* block prefix & suffix */
typedef struct BlockPrefix_s {
  struct BlockSuffix_s *suffix;
  int allocated;
} BlockPrefix_t;

typedef struct BlockSuffix_s {
  struct BlockPrefix_s *prefix;
} BlockSuffix_t;


//typedefing pointers to findFit funcs
typedef BlockPrefix_t* (*findFitFunc)(size_t);

//and defining all functions here, so that we do not redefine them ahead of time
void freeRegion(void *r);
void *resizeRegion(void *r, size_t newSize);
void *resizeRegionPtr(void *r, size_t newSize, findFitFunc ffunc);

void *AllocRegionPtr(size_t s, findFitFunc ffunc);

//defs 4 findFuncs
BlockPrefix_t *findFirstFit(size_t s);
BlockPrefix_t *findNextFit(size_t s);
BlockPrefix_t *findBestFit(size_t s);

//re-inits the arena, i.e. allocates a new arena
void clearArena();

